diff --git a/drivers/gpu/drm/arm/hdlcd_drv.c b/drivers/gpu/drm/arm/hdlcd_drv.c
index aa06f9838015..8d1f3b6157ed 100644
--- a/drivers/gpu/drm/arm/hdlcd_drv.c
+++ b/drivers/gpu/drm/arm/hdlcd_drv.c
@@ -194,7 +194,7 @@ static int hdlcd_setup_mode_config(struct drm_device *drm)
 static int hdlcd_show_underrun_count(struct seq_file *m, void *arg)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *drm = entry->dev;
+	struct drm_device *drm = entry->drm;
 	struct hdlcd_drm_private *hdlcd = drm_to_hdlcd_priv(drm);
 
 	seq_printf(m, "underrun : %d\n", atomic_read(&hdlcd->buffer_underrun_count));
@@ -207,7 +207,7 @@ static int hdlcd_show_underrun_count(struct seq_file *m, void *arg)
 static int hdlcd_show_pxlclock(struct seq_file *m, void *arg)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *drm = entry->dev;
+	struct drm_device *drm = entry->drm;
 	struct hdlcd_drm_private *hdlcd = drm_to_hdlcd_priv(drm);
 	unsigned long clkrate = clk_get_rate(hdlcd->clk);
 	unsigned long mode_clock = hdlcd->crtc.mode.crtc_clock * 1000;
diff --git a/drivers/gpu/drm/drm_atomic.c b/drivers/gpu/drm/drm_atomic.c
index 8c2ebb982972..58101873a651 100644
--- a/drivers/gpu/drm/drm_atomic.c
+++ b/drivers/gpu/drm/drm_atomic.c
@@ -1820,7 +1820,7 @@ EXPORT_SYMBOL(drm_state_dump);
 static int drm_state_info(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct drm_printer p = drm_seq_file_printer(m);
 
 	__drm_state_dump(dev, &p, true);
diff --git a/drivers/gpu/drm/drm_client.c b/drivers/gpu/drm/drm_client.c
index a99417748053..3b82635dc9ff 100644
--- a/drivers/gpu/drm/drm_client.c
+++ b/drivers/gpu/drm/drm_client.c
@@ -500,7 +500,7 @@ EXPORT_SYMBOL(drm_client_framebuffer_flush);
 static int drm_client_debugfs_internal_clients(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct drm_printer p = drm_seq_file_printer(m);
 	struct drm_client_dev *client;
 
diff --git a/drivers/gpu/drm/drm_debugfs.c b/drivers/gpu/drm/drm_debugfs.c
index 3a70ac678e8f..4542eed896dd 100644
--- a/drivers/gpu/drm/drm_debugfs.c
+++ b/drivers/gpu/drm/drm_debugfs.c
@@ -52,7 +52,7 @@
 static int drm_name_info(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct drm_master *master;
 
 	mutex_lock(&dev->master_mutex);
@@ -73,7 +73,7 @@ static int drm_name_info(struct seq_file *m, void *data)
 static int drm_clients_info(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct drm_file *priv;
 	kuid_t uid;
 
@@ -125,7 +125,7 @@ static int drm_gem_one_name_info(int id, void *ptr, void *data)
 static int drm_gem_name_info(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 
 	seq_printf(m, "  name     size handles refcount\n");
 
@@ -337,7 +337,7 @@ void drm_debugfs_add_file(struct drm_device *dev, const char *name,
 	entry->file.name = name;
 	entry->file.show = show;
 	entry->file.data = data;
-	entry->dev = dev;
+	entry->drm = dev;
 
 	mutex_lock(&dev->debugfs_mutex);
 	list_add(&entry->list, &dev->debugfs_list);
diff --git a/drivers/gpu/drm/drm_framebuffer.c b/drivers/gpu/drm/drm_framebuffer.c
index aff3746dedfb..38a118e51a6f 100644
--- a/drivers/gpu/drm/drm_framebuffer.c
+++ b/drivers/gpu/drm/drm_framebuffer.c
@@ -1204,7 +1204,7 @@ void drm_framebuffer_print_info(struct drm_printer *p, unsigned int indent,
 static int drm_framebuffer_info(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct drm_printer p = drm_seq_file_printer(m);
 	struct drm_framebuffer *fb;
 
diff --git a/drivers/gpu/drm/drm_gem_vram_helper.c b/drivers/gpu/drm/drm_gem_vram_helper.c
index b67eafa55715..fc45a65708b7 100644
--- a/drivers/gpu/drm/drm_gem_vram_helper.c
+++ b/drivers/gpu/drm/drm_gem_vram_helper.c
@@ -969,7 +969,7 @@ static struct ttm_device_funcs bo_driver = {
 static int drm_vram_mm_debugfs(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_vram_mm *vmm = entry->dev->vram_mm;
+	struct drm_vram_mm *vmm = entry->drm->vram_mm;
 	struct ttm_resource_manager *man = ttm_manager_type(&vmm->bdev, TTM_PL_VRAM);
 	struct drm_printer p = drm_seq_file_printer(m);
 
diff --git a/drivers/gpu/drm/gud/gud_drv.c b/drivers/gpu/drm/gud/gud_drv.c
index 9d7bf8ee45f1..a613407ac2df 100644
--- a/drivers/gpu/drm/gud/gud_drv.c
+++ b/drivers/gpu/drm/gud/gud_drv.c
@@ -326,7 +326,7 @@ static struct drm_gem_object *gud_gem_prime_import(struct drm_device *drm, struc
 static int gud_stats_debugfs(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct gud_device *gdrm = to_gud_device(entry->dev);
+	struct gud_device *gdrm = to_gud_device(entry->drm);
 	char buf[10];
 
 	string_get_size(gdrm->bulk_len, 1, STRING_UNITS_2, buf, sizeof(buf));
diff --git a/drivers/gpu/drm/v3d/v3d_debugfs.c b/drivers/gpu/drm/v3d/v3d_debugfs.c
index 330669f51fa7..54a9cfbb5a7d 100644
--- a/drivers/gpu/drm/v3d/v3d_debugfs.c
+++ b/drivers/gpu/drm/v3d/v3d_debugfs.c
@@ -80,7 +80,7 @@ static const struct v3d_reg_def v3d_csd_reg_defs[] = {
 static int v3d_v3d_debugfs_regs(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct v3d_dev *v3d = to_v3d_dev(dev);
 	int i, core;
 
@@ -127,7 +127,7 @@ static int v3d_v3d_debugfs_regs(struct seq_file *m, void *unused)
 static int v3d_v3d_debugfs_ident(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct v3d_dev *v3d = to_v3d_dev(dev);
 	u32 ident0, ident1, ident2, ident3, cores;
 	int core;
@@ -189,7 +189,7 @@ static int v3d_v3d_debugfs_ident(struct seq_file *m, void *unused)
 static int v3d_debugfs_bo_stats(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct v3d_dev *v3d = to_v3d_dev(dev);
 
 	mutex_lock(&v3d->bo_lock);
@@ -205,7 +205,7 @@ static int v3d_debugfs_bo_stats(struct seq_file *m, void *unused)
 static int v3d_measure_clock(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct v3d_dev *v3d = to_v3d_dev(dev);
 	uint32_t cycles;
 	int core = 0;
diff --git a/drivers/gpu/drm/vc4/vc4_bo.c b/drivers/gpu/drm/vc4/vc4_bo.c
index 86d629e45307..71a6f5e47817 100644
--- a/drivers/gpu/drm/vc4/vc4_bo.c
+++ b/drivers/gpu/drm/vc4/vc4_bo.c
@@ -70,7 +70,7 @@ static void vc4_bo_stats_print(struct drm_printer *p, struct vc4_dev *vc4)
 static int vc4_bo_stats_debugfs(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct vc4_dev *vc4 = to_vc4_dev(dev);
 	struct drm_printer p = drm_seq_file_printer(m);
 
diff --git a/drivers/gpu/drm/vc4/vc4_debugfs.c b/drivers/gpu/drm/vc4/vc4_debugfs.c
index fac624a663ea..1af0432ee6a1 100644
--- a/drivers/gpu/drm/vc4/vc4_debugfs.c
+++ b/drivers/gpu/drm/vc4/vc4_debugfs.c
@@ -35,7 +35,7 @@ vc4_debugfs_init(struct drm_minor *minor)
 static int vc4_debugfs_regset32(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *drm = entry->dev;
+	struct drm_device *drm = entry->drm;
 	struct debugfs_regset32 *regset = entry->file.data;
 	struct drm_printer p = drm_seq_file_printer(m);
 	int idx;
diff --git a/drivers/gpu/drm/vc4/vc4_hvs.c b/drivers/gpu/drm/vc4/vc4_hvs.c
index 488a207024c7..552142320e2d 100644
--- a/drivers/gpu/drm/vc4/vc4_hvs.c
+++ b/drivers/gpu/drm/vc4/vc4_hvs.c
@@ -94,7 +94,7 @@ void vc4_hvs_dump_state(struct vc4_hvs *hvs)
 static int vc4_hvs_debugfs_underrun(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct vc4_dev *vc4 = to_vc4_dev(dev);
 	struct drm_printer p = drm_seq_file_printer(m);
 
@@ -106,7 +106,7 @@ static int vc4_hvs_debugfs_underrun(struct seq_file *m, void *data)
 static int vc4_hvs_debugfs_dlist(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct vc4_dev *vc4 = to_vc4_dev(dev);
 	struct vc4_hvs *hvs = vc4->hvs;
 	struct drm_printer p = drm_seq_file_printer(m);
diff --git a/drivers/gpu/drm/vc4/vc4_v3d.c b/drivers/gpu/drm/vc4/vc4_v3d.c
index 04ac7805e6d5..72edeb2d3d78 100644
--- a/drivers/gpu/drm/vc4/vc4_v3d.c
+++ b/drivers/gpu/drm/vc4/vc4_v3d.c
@@ -97,7 +97,7 @@ static const struct debugfs_reg32 v3d_regs[] = {
 static int vc4_v3d_debugfs_ident(struct seq_file *m, void *unused)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct vc4_dev *vc4 = to_vc4_dev(dev);
 	int ret = vc4_v3d_pm_get(vc4);
 
diff --git a/drivers/gpu/drm/vkms/vkms_drv.c b/drivers/gpu/drm/vkms/vkms_drv.c
index a58d7e0d3078..f15f1bd51208 100644
--- a/drivers/gpu/drm/vkms/vkms_drv.c
+++ b/drivers/gpu/drm/vkms/vkms_drv.c
@@ -93,7 +93,7 @@ static void vkms_atomic_commit_tail(struct drm_atomic_state *old_state)
 static int vkms_config_show(struct seq_file *m, void *data)
 {
 	struct drm_debugfs_entry *entry = m->private;
-	struct drm_device *dev = entry->dev;
+	struct drm_device *dev = entry->drm;
 	struct vkms_device *vkmsdev = drm_device_to_vkms_device(dev);
 
 	seq_printf(m, "writeback=%d\n", vkmsdev->config->writeback);
diff --git a/include/drm/drm_debugfs.h b/include/drm/drm_debugfs.h
index 7616f457ce70..f7c4f2774a8e 100644
--- a/include/drm/drm_debugfs.h
+++ b/include/drm/drm_debugfs.h
@@ -112,8 +112,8 @@ struct drm_debugfs_info {
  * drm_debugfs_info on a &struct drm_device.
  */
 struct drm_debugfs_entry {
-	/** @dev: &struct drm_device for this node. */
-	struct drm_device *dev;
+	/** @drm: &struct drm_device for this node. */
+	struct drm_device *drm;
 
 	/** @file: Template for this node. */
 	struct drm_debugfs_info file;